#include <fstream.h>

ifstream IN;
int Size;
int Matrix[10][10];

bool Check()
{
  int Sum1 = 0;
  int Sum2 = 0;
  for (int i=0; i<Size; i++) {
    Sum1 += Matrix[i][i];
    Sum2 += Matrix[i][Size-1-i];
  }
  if (Sum1 != Sum2) return false;
  int SUM = Sum1;
  for (int x=0; x<Size; x++) {
    int Sum = 0;
    for (int y=0; y<Size; y++) Sum += Matrix[x][y];
    if (Sum != SUM) return false;
  }
  for (int y=0; y<Size; y++) {
    int Sum = 0;
    for (int x=0; x<Size; x++) Sum += Matrix[x][y];
    if (Sum != SUM) return false;
  }
  return true;
}

int main()
{
  IN.open("magic.in");
  for (int Run=1; true; Run++) {
    IN >> Size;
    if (Size == 0) break;
    for (int y=0; y<Size; y++)
      for (int x=0; x<Size; x++)
        IN >> Matrix[x][y];
    cout << "Square " << Run << endl;
    if (Check()) cout << "This square is magic." << endl;
            else cout << "This square is not magic." << endl;
    cout << endl;
  }
  IN.close();
}
